---
title: XMLHttpRequest.readyState
slug: Web/API/XMLHttpRequest/readyState
tags:
  - AJAX
  - Property
  - Reference
  - XMLHttpRequest
---
<p>{{APIRef('XMLHttpRequest')}}</p>

<p>The <strong>XMLHttpRequest.readyState</strong> property returns the state an XMLHttpRequest client is in. An <abbr title="XMLHttpRequest">XHR</abbr> client exists in one of the following states:</p>

<table class="standard-table">
 <tbody>
  <tr>
   <td class="header">Value</td>
   <td class="header">State</td>
   <td class="header">Description</td>
  </tr>
  <tr>
   <td><code>0</code></td>
   <td><code>UNSENT</code></td>
   <td>Client has been created. <code>open()</code> not called yet.</td>
  </tr>
  <tr>
   <td><code>1</code></td>
   <td><code>OPENED</code></td>
   <td><code>open()</code> has been called.</td>
  </tr>
  <tr>
   <td><code>2</code></td>
   <td><code>HEADERS_RECEIVED</code></td>
   <td><code>send()</code> has been called, and headers and status are available.</td>
  </tr>
  <tr>
   <td><code>3</code></td>
   <td><code>LOADING</code></td>
   <td>Downloading; <code>responseText</code> holds partial data.</td>
  </tr>
  <tr>
   <td><code>4</code></td>
   <td><code>DONE</code></td>
   <td>The operation is complete.</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt>UNSENT</dt>
 <dd>The XMLHttpRequest client has been created, but the open() method hasn't been called yet.</dd>
 <dt>OPENED</dt>
 <dd>open() method has been invoked. During this state, the request headers can be set using the <a href="/en-US/docs/Web/API/XMLHttpRequest/setRequestHeader">setRequestHeader()</a> method and the <a href="/en-US/docs/Web/API/XMLHttpRequest/send">send()</a> method can be called which will initiate the fetch.</dd>
 <dt>HEADERS_RECEIVED</dt>
 <dd>send() has been called and the response headers have been received.</dd>
 <dt>LOADING</dt>
 <dd>Response's body is being received. If <code><a href="/en-US/docs/Web/API/XMLHttpRequest/responseType">responseType</a></code> is "text" or empty string, <code><a href="/en-US/docs/Web/API/XMLHttpRequest/responseText">responseText</a></code> will have the partial text response as it loads.</dd>
 <dt>DONE</dt>
 <dd>The fetch operation is complete. This could mean that either the data transfer has been completed successfully or failed.</dd>
</dl>

<div class="note">
<p>The state names are different in versions of Internet Explorer earlier than 11. Instead of <code>UNSENT</code>, <code>OPENED</code>,<code> HEADERS_RECEIVED</code>,<code> LOADING</code> and <code>DONE</code>, the names <code>READYSTATE_UNINITIALIZED</code> (0), <code>READYSTATE_LOADING</code> (1), <code>READYSTATE_LOADED</code> (2), <code>READYSTATE_INTERACTIVE</code> (3) and <code>READYSTATE_COMPLETE</code> (4) are used.</p>
</div>

<h2 id="Example">Example</h2>

<pre class="brush: js">var xhr = new XMLHttpRequest();
console.log('UNSENT', xhr.readyState); // readyState will be 0

xhr.open('GET', '/api', true);
console.log('OPENED', xhr.readyState); // readyState will be 1

xhr.onprogress = function () {
    console.log('LOADING', xhr.readyState); // readyState will be 3
};

xhr.onload = function () {
    console.log('DONE', xhr.readyState); // readyState will be 4
};

xhr.send(null);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#states')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.readyState")}}</p>
